#ifndef __LAMEFWD_H__
#define __LAMEFWD_H__

#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>

#include <netinet/in.h>
#include <arpa/inet.h>

enum {	FWD_TCP,
	FWD_UDP };
enum {	CONN_NO,
	CONN_IN_PROG,
	CONN_YES };

struct fwdent {
	unsigned int 	localport;
	unsigned int 	remoteport;
	int		proto;
	int		listenfd;
	struct sockaddr_in	sin;
	int		dgramfd;
	struct sockaddr	sender; /* for dgrams */
	socklen_t	senderlen;
};

#define U2S_SIZE 2048 /* Buffered data going from user to server */
#define S2U_SIZE 2048 /* Buffered data going from server to user */
#define BUF_SIZE 2048 /* Input from user to program */

struct ud {
	int		user_fd;
	int		serv_fd;
  	unsigned char 	u2s_buf[U2S_SIZE];  /* from user to server        */
  	unsigned char 	s2u_buf[S2U_SIZE];  /* from server to user        */
  	unsigned char 	*u2s_i;        	/* user to server, input ptr  */
  	unsigned char 	*u2s_o;        	/* user to server, output ptr */
  	unsigned char 	*s2u_i;        	/* server to user, input ptr  */
  	unsigned char 	*s2u_o;        	/* server to user, output ptr */
	int		connected;
	int		fwdidx;		/* index to fwdent structure */
};

#endif /* !__LAMEFWD_H__ */
